aboutsummaryrefslogtreecommitdiff
path: root/sci/electronics/iverilog/iverilog.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'sci/electronics/iverilog/iverilog.SlackBuild')
-rwxr-xr-xsci/electronics/iverilog/iverilog.SlackBuild147
1 files changed, 147 insertions, 0 deletions
diff --git a/sci/electronics/iverilog/iverilog.SlackBuild b/sci/electronics/iverilog/iverilog.SlackBuild
new file mode 100755
index 00000000..4fc66098
--- /dev/null
+++ b/sci/electronics/iverilog/iverilog.SlackBuild
@@ -0,0 +1,147 @@
+#!/bin/bash
+#
+# SlackBuild for Icarus Verilog
+# http://www.icarus.com/eda/verilog/
+#
+# Author: Luis ( luis at riseup d0t net )
+#
+
+CWD=`pwd`
+
+# Look for slackbuildrc
+if [ -f ~/.slackbuildrc ]; then
+ source ~/.slackbuildrc
+elif [ -f /etc/slackbuildrc ]; then
+ source /etc/slackbuildrc
+fi
+
+# Set variables
+SRC_NAME="verilog"
+PKG_NAME="iverilog"
+ARCH=${ARCH:=i486}
+VERSION=${VERSION:=0.8.3}
+BUILD=${BUILD:=1ls}
+SRC_DIR=${SRC_DIR:=$CWD}
+TMP=${TMP:=/tmp}
+PKG=${PKG:=$TMP/package-$PKG_NAME}
+REPOS=${REPOS:=$TMP}
+PREFIX=${PREFIX:=/usr}
+PKG_SRC=$SRC_NAME-$VERSION
+
+# Set system libraries' path and optmization flags based on $ARCH
+LIBDIR=$PREFIX/lib
+
+if [ "$ARCH" = "i386" ]; then
+ SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+elif [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mcpu=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIR="$PREFIX/lib64"
+fi
+
+# Set error codes (used by createpkg)
+ERROR_WGET=31; ERROR_MAKE=32; ERROR_INSTALL=33
+ERROR_MD5=34; ERROR_CONF=35; ERROR_HELP=36
+ERROR_TAR=37; ERROR_MKPKG=38; ERROR_GPG=39
+ERROR_PATCH=40; ERROR_VCS=41; ERROR_MKDIR=42
+
+# Clean up any leftovers of previous builds
+rm -rf $PKG_SRC 2>/dev/null
+rm -rf $PKG 2>/dev/null
+
+# Create directories, if necessary
+mkdir -p $SRC_DIR || exit $ERROR_MKDIR
+mkdir -p $PKG || exit $ERROR_MKDIR
+mkdir -p $REPOS || exit $ERROR_MKDIR
+
+# Dowload source, if necessary
+SRC="$PKG_SRC.tar.gz"
+URL="ftp://ftp.icarus.com/pub/eda/verilog/v0.8/$SRC"
+
+if [ ! -f "$SRC_DIR/$SRC" ]; then
+ wget "$URL" -O "$SRC_DIR/$SRC" || exit $ERROR_WGET
+fi
+
+# Untar, configure, compile and install
+tar --no-same-owner --no-same-permissions -xvf $SRC_DIR/$SRC || exit $ERROR_TAR
+cd $PKG_SRC
+CFLAGS="$SLKCFLAGS" \
+ CXXFLAGS="$SLKCFLAGS" \
+ ./configure \
+ --prefix=$PREFIX --libdir=$LIBDIR || exit $ERROR_CONF
+make || exit $ERROR_MAKE
+make install prefix=$PKG/$PREFIX || exit $ERROR_INSTALL
+
+# Strip binaries
+( cd $PKG
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+)
+
+# Compress and link manpages, if any
+if [ -d $PKG/$PREFIX/man ]; then
+ ( cd $PKG/$PREFIX/man
+ for manpagedir in $(find . -type d -name "man*") ; do
+ ( cd $manpagedir
+ for eachpage in $( find . -type l -maxdepth 1) ; do
+ ln -s $( readlink $eachpage ).gz $eachpage.gz
+ rm $eachpage
+ done
+ gzip -9 *.?
+ )
+ done
+ )
+fi
+
+# Compress info files, if any
+if [ -d $PKG/$PREFIX/info ]; then
+ ( cd $PKG/$PREFIX/info
+ rm -f dir
+ gzip -9 *
+ )
+fi
+
+# Install documentation and examples
+mkdir -p $PKG/$PREFIX/doc/$PKG_NAME-$VERSION/vvp || exit $ERROR_MKDIR
+cp -a COPYING INSTALL *.txt examples $PKG/$PREFIX/doc/$PKG_NAME-$VERSION
+cp -a vvp/*.txt vvp/examples $PKG/$PREFIX/doc/$PKG_NAME-$VERSION/vvp
+
+# Add slack-desc file
+mkdir -p $PKG/install || exit $ERROR_MKDIR
+cat << EOF > $PKG/install/slack-desc
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+iverilog: iverilog (Icarus Verilog)
+iverilog:
+iverilog: The Icarus verilog compiler for the Verilog hardware description
+iverilog: language (HDL), as described in the IEEE-1364 standard. The compiler
+iverilog: can target either simulation, or netlist (XNF).
+iverilog:
+iverilog: For more information, http://www.icarus.com/eda/verilog/
+iverilog:
+iverilog:
+iverilog:
+iverilog:
+EOF
+
+# Build the package
+cd $PKG
+makepkg -l y -c n $REPOS/$PKG_NAME-$VERSION-$ARCH-$BUILD.tgz || exit $ERROR_MKPKG
+
+# Delete source and build directories, if requested
+if [ "$CLEANUP" == "yes" ]; then
+ rm -rf $CWD/$PKG_SRC $PKG
+fi